import josx.platform.rcx.*;
import myTools.*;


public class COne {

	/*
	 * 
	 * Author Antrophos
	 * 
	 * Dies ist der Code des ersten Roboters. Er hat eine simple Sequenz von Aufgaben zu lsen.
	 * 1. Kalibrieung
	 * 2. Das bereitstellen einer Kiste(3x)
	 *  1) Weg zur Kiste finden
	 *  2) Kiste greifen
	 *  3) mit Kiste drehen
	 *  4) Kiste in den bergaberaum schieben
	 *  5) Warten auf bergabebesttigung
	 *  6) Weg zur nchsten Kiste finden(a)
	 *  7) Ende
	 * 
	 */
	
	static myOptic optic;				// Objekt fr den Lichtsensor
	
	static int operation;				// aktuelle Operation
	static int packagecounter;			// Anzahl der geschleppten Kisten
	static int maxpkg = 3;				// Aufgabendeffinition
	static int aktcolor;				// Variable zum Farbe speichern
	static int greencounter;			// Hilfsvariable um grn besser zu erkennen
	static boolean ldr;					// ldr = last direcion right(klingt cooler als ldl)

	static Motor M_left = Motor.C;		// linker Motor
	static Motor M_right = Motor.A;		// rechter Motor

	static int maxPower = 5;			//Maxpower auf Motoren
	static int maxTurn = 4;				//Maxpower auf Motoren
	
	static int linesToIgnore;
	
	
	static void powerMotor(Motor m,int maxSpeed){
		if(!m.isForward()){
			if (m.getPower()>1)
				m.setPower(m.getPower()-1);
			else
				m.setPower(1);
//			m.forward();
		}
		else if (m.getPower() < maxSpeed){
			m.setPower(m.getPower()+1);
		}
		else if (m.getPower() > maxSpeed)
			m.setPower(m.getPower()-1);
	}
	
	static void floatMotor(Motor m,int maxSpeed){
		if(!m.isBackward()){
			if (m.getPower()>1)
				m.setPower(m.getPower()-1);
			else
				m.setPower(1);
//			m.backward();
		}
		else if (m.getPower() < maxSpeed){
			m.setPower(m.getPower()+1);
		}
		else if (m.getPower() > maxSpeed)
			m.setPower(m.getPower()-1);
	}
	
	static void turn(boolean turnRight){
		if (turnRight){
			floatMotor(M_right,maxTurn);
			powerMotor(M_left,maxTurn);
		}
		else {
			floatMotor(M_left,maxTurn);
			powerMotor(M_right,maxTurn);
		}
	}
	
	
	static int turns;
	static int turnsdone;		//Variablen fr pathfinder
	
	static boolean pathfinder(){
		turns = 20;
		while (turns < 1000){
			for (turnsdone=0;turnsdone<turns;turnsdone++){
				turn(ldr);
				myTools.sleep(10);
				optic.getColor();
				if (optic.isBlack())return true;
			}
			turns = turns * 2;
			ldr= !ldr;
		}
		return false;
	}
	
	static boolean checkgreenline(){
		for (turnsdone=0;turnsdone<30;turnsdone++){
			turn(!ldr);
			myTools.sleep(10);
		}
		optic.getColor();
		if (optic.isGreen()){
			for (turnsdone=0;turnsdone<65;turnsdone++){
				turn(ldr);
				myTools.sleep(10);
			}
			optic.getColor();
			if (optic.isGreen()){
				for (turnsdone=0;turnsdone<35;turnsdone++){
					turn(!ldr);
					myTools.sleep(10);
				}
				operation++;
				return true;
			}
		}
		return false;
	}
	
	static void maneuver(int nr){
		if (nr==2){
			for (turnsdone=0;turnsdone<100;turnsdone++){
				powerMotor(M_left,maxPower);
				powerMotor(M_right,maxPower);
				myTools.sleep(10);
				li
			}
			turnarround();
		}
	}
	
	static void laufen(){
		// Definitionsbereich
		operation = 1;
		packagecounter = 0;
		while (operation<7){
			if (operation==1){
				
				aktcolor = optic.getColor();
				if (optic.isBlack()){
					greencounter=0;
					powerMotor(M_left,maxPower);
					powerMotor(M_right,maxPower);
				
				}
				else if (optic.isGreen())
				{
					greencounter++;
					if (greencounter==50)
						if (checkgreenline()){
							Sound.buzz();
							maneuver(operation);
						}
					LCD.showNumber(greencounter);
					
				}
				else if (!pathfinder()) operation = 8;
			}
	
		
		}

	}
	
	static void turnarround(){
		M_left.setPower(0);
		M_right.setPower(0);
		turn(true);
		myTools.sleep(300);
		optic.getColor();
		while (!optic.isWhite()){
			turn(true);
			optic.getColor();
			myTools.sleep(10);
		}
		while (optic.isWhite()){
			turn(true);
			optic.getColor();
			myTools.sleep(10);
		}
	}
	
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		optic = new myOptic(Sensor.S1);
		if (optic.calibrating("S1"))
			laufen() ;
	}

}
